#include "nrf_gpio.h"
#include "nrf_delay.h"
#include "nrf.h"

#define LED_PIN 16       // Adjust to your board's LED pin
#define BUTTON_PIN 11    // Adjust to your board's button pin
#define APP1_START_ADDR 0x0  // Address for App1

typedef void (*app_entry_t)(void);

void app2_main() {
    nrf_gpio_cfg_output(LED_PIN);
    nrf_gpio_cfg_input(BUTTON_PIN, NRF_GPIO_PIN_PULLUP);

    while (1) {
        nrf_gpio_pin_toggle(LED_PIN);  // Toggle LED
        nrf_delay_ms(100);  // Wait for 100 ms

          if (nrf_gpio_pin_read(BUTTON_PIN) == 0) {  // Button press detected
          nrf_delay_ms(50);  // Debounce delay

          if (nrf_gpio_pin_read(BUTTON_PIN) == 0) {

      uint32_t app1_sp = *(volatile uint32_t *)APP1_START_ADDR;  // App1 stack pointer
      uint32_t app1_reset_vector = *(volatile uint32_t *)(APP1_START_ADDR + 4);  // App1's reset vector

      // Validate stack pointer and reset vector
      if (app1_sp >= 0x20000000 && app1_sp <= 0x20080000 && app1_reset_vector >= APP1_START_ADDR && app1_reset_vector < APP1_START_ADDR + 0x40000)
       {
       __disable_irq();  // Disable interrupts
       __set_MSP(app1_sp);  // Set the stack pointer to App1's SP
       SCB->VTOR = APP1_START_ADDR;  // Update VTOR to point to App1's vector table
       __enable_irq();  // Enable interrupts if necessary

          void (*app1_entry)() = (void (*)())app1_reset_vector;  // Cast to function pointer
          app1_entry();  // Jump to App1

          //uint32_t app1_sp = *(volatile uint32_t *)APP1_START_ADDR;  // App2 stack pointer

          //  __set_MSP(app1_sp);  // Set the stack pointer to App2's SP

          //  SCB->VTOR = APP1_START_ADDR;  // Update VTOR to point to the new app

          //  uint32_t app1_reset_vector = *(volatile uint32_t *)(APP1_START_ADDR + 4);  // App2's reset vector
          //  void (*app1_entry)() = (void (*)())app1_reset_vector;  // Cast to function pointer
          //          app1_entry();  // Jump to App2

        }
      }
    }
  }
}

int main() {
    app2_main();  // Start Code 2 (100 ms blink)
    return 0;
}
